#include <rtm/Manager.h>
#include <rtm/DataFlowComponentBase.h>
#include <rtm/CorbaPort.h>

#include "TestPortServiceInfo_RTM_Impl.h"
#include "CustomDynamicService_RTM_Impl.h"

namespace CyberDevice
{
	class DynamicPortReceiver : public RTC::DataFlowComponentBase
	{
	public:
		DynamicPortReceiver(RTC::Manager *_manager);
		~DynamicPortReceiver();
		static void AdapterInit(RTC::Manager* manager);

		RTC::ReturnCode_t onStartup(RTC::UniqueId exec_handle);
		RTC::ReturnCode_t onExecute(RTC::UniqueId exec_handle);
		RTC::ReturnCode_t onActivated(RTC::UniqueId exec_handle);
		RTC::ReturnCode_t onDeactivated(RTC::UniqueId exec_handle);
		RTC::ReturnCode_t onReset(RTC::UniqueId exec_handle);

		// TestPortServiceInfoImpl calls these
		RTC::PortService_ptr getPortInfo(const char* name);
		void addCustomProvider(const char* name);

		// CustomDynamicServiceImpl calls this
		void notify_function_called();

	private:
		// port&service which instructs this class to create custom port
		PortServiceInfoImpl *mpPortServiceImpl;
		RTC::CorbaPort mPortServicePort;

		// custom port&service to create
		CustomDynamicServiceImpl *mpCustomServiceImpl;
		RTC::CorbaPort mCustomPort;

		bool mbCustomPortConnected;
		bool mbCustomPortCreated;
	};
}